#
# hello.mic.45.py
#
# plot microphone audio
#
# Neil Gershenfeld
# CBA MIT 10/28/07
#
# (c) Massachusetts Institute of Technology 2007
# Permission granted for experimental and personal use;
# license for commercial sale available from MIT
#

from Tkinter import *
import serial

NX = 100
NY = 500
nloop = 100
nstart = 10
path = []
c_x = 0




def idle(parent,canvas):
   global path
   global c_x
   #
   # idle routine
   #
   # look for framing
   #
   byte2 = 0
   byte3 = 0
   byte4 = 0
   while 1:
      byte1 = byte2
      byte2 = byte3
      byte3 = byte4
      byte4 = ord(ser.read())
      if ((byte1 == 1) & (byte2 == 2) & (byte3 == 3) & (byte4 == 4)):
         break
   path = []
   for i in range(nstart):
      lo = ord(ser.read())
      hi = ord(ser.read())
   for i in range(nloop):
      lo = ord(ser.read())
      hi = ord(ser.read())
      reading = 256*hi + lo
      value = NY*(1.0-reading/1024.0)
      path.append(3*i)
      path.append(value)
   canvas.delete("path")
   canvas.create_line(path,tag="path",width=1,fill='blue')

   min_lo = ord(ser.read())
   min_hi = ord(ser.read())
   minVal = 256 * min_hi + min_lo
   max_lo = ord(ser.read())
   max_hi = ord(ser.read())
   maxVal = 256 * max_hi + max_lo
   zero_lo = ord(ser.read())
   zero_hi = ord(ser.read())
   zeroVal = 256 * zero_hi + zero_lo
   zero_crossings = ord(ser.read())

   #print(zero_crossings)



   zeroLine = []
   scaledZeroVal = NY*(1.0-zeroVal/1024.0)
   zeroLine.append(0);
   zeroLine.append(scaledZeroVal);
   zeroLine.append(NX*nloop);
   zeroLine.append(scaledZeroVal);

#
#  check command line arguments
#
if (len(sys.argv) != 2):
   print "command line: hello.mic.45.py serial_port"
   sys.exit()
port = sys.argv[1]
#
# open serial port
#
ser = serial.Serial(port,9600)
#
#ser = serial.Serial('/dev/ttyS0',115200)
#ser = serial.Serial('/dev/ttyUSB0',115200)
ser.setDTR()
#
# start plotting
#
root = Tk()
root.title('hello.mic.45.py')
root.bind('q','exit')
canvas = Canvas(root, width=3*NX, height=NY/2, background='cyan')
canvas.pack()
root.after(100,idle,root,canvas)
root.mainloop()
